;;**************************************************************;;
;;--------------------------------------------------------------;;
;; Problem File: Mission Impossible: Simple Mission 1		;;
;; Author:	 Anthony G. Francis, Jr.			;;
;; Assignment:	 Visiting Research Work.			;;
;; Due:		 Not Specified					;;
;;--------------------------------------------------------------;;
;; Module:	 Mission Impossible Domain version 1		;;
;; File:	 "probs/compete-challenger.lisp"		;;
;;--------------------------------------------------------------;;
;; Notes: 							;;
;;--------------------------------------------------------------;;
;;**************************************************************;;

;;**************************************************************;;
;; PROBLEM DEFINITION						;;
;;**************************************************************;;
(setf (current-problem)
      (create-problem
       ;;-------------------------------------------------------
       ;; PROBLEM NAME
       ;;-------------------------------------------------------
       (name compete-challenger)

       ;;-------------------------------------------------------
       ;; OBJECT DECLARATIONS
       ;;-------------------------------------------------------
       (objects

	;;=====================================================
	;; Largely Fixed Domain Objects
	;;=====================================================
	;;--- UNITED STATES ------
	(Area51  Place)
	(Roswell   Place)

	;;=====================================================
	;; Changeable Problem Objects
	;;=====================================================
	;;--- MOBILE OBJECTS------
	(AlienBody Secret)
	(JFKsBrain Secret)
	)

       ;;-------------------------------------------------------
       ;; INITIAL STATE
       ;;-------------------------------------------------------
       (state 
	(and 
	 ;;=====================================================
	 ;; Largely Fixed Domain Knowledge
	 ;;=====================================================

	 ;;=====================================================
	 ;; Changeable Problem Knowledge
	 ;;=====================================================
	 ;;--- PLACES -------------
	 (insecure Area51)

	 ;;--- SECRETS ------------
	 (stored      AlienBody Area51)
	 (stored      JFKsBrain Area51)

	 ;;--- PEOPLE -------------
	 (at          Area51)

	 ;;--- PASSPORTS ----------
	 (pass        Area51      Roswell)
	 )
	)

       ;;-------------------------------------------------------
       ;; GOAL STATE
       ;;-------------------------------------------------------
       (goal (and
	      (holding AlienBody)
	      (holding JFKsBrain)
	      (at Roswell)	
	      )
	     )
       )
      )
